////////////////////////////////////////////////////////////////////////////////
//  System: K- API
//  Module: LDefin2D
////////////////////////////////////////////////////////////////////////////////
unit LDefin2D;

{$ALIGN OFF}

interface  

type
  Reference = Longint;

const
  TEXT_LENGTH      = 128;
  MAX_TEXT_LENGTH  = 255;
  etNoAllDocument = -6;  // "  
  etNoSPCDocument = -5;  // "      
  etLibraryClose  = -4;  // "   
  etNoPreView     = -3;  // "  Preview      
  etNoDocument    = -2;  // "      /
  etAbort         = -1;  // "  (?)
  etSuccess       = 0;   // " 
  etError1        = 1;   // "!   EndObj \n\r    "
  etError2        = 2;   // "!     \n\r  "
  etError3        = 3;   // "!     \n\r  "
  etError4        = 4;   // "!   delete_mtr /n /r     "
  etError5        = 5;   // "     "
  etError6        = 6;   // " !    "
  etError7        = 7;   // " !   "
  etError8        = 8;   // "!      "
  etError9        = 9;   // "!  !"
  etError10       = 10;  // "!  "
  etError11       = 11;  // " !   
  etError12       = 12;  // " !    
  etError13       = 13;  // " !     
  etError14       = 14;  // " !    
  etError15       = 15;  // "        
  etError16       = 16;  // "        
  etError17       = 17;  // "    
  etError18       = 18;  // "     (  )
  etError19       = 19;  // "    
  etError20       = 20;  // "    
  etError21       = 21;  // "   
  etError22       = 22;  // "!      \n\r   "
  etError23       = 23;  // "      "
  etError24       = 24;  // "!      "
  etError25       = 25;  // "!    "
  etError26       = 26;  // "!      "
  etError27       = 27;  // "!   
  etError28       = 28;  // "!   
  etError29       = 29;  // "!    "
  etError30       = 30;  // "!     "
  etError31       = 31;  // "!   "
  etError32       = 32;  // "!     "
  etError33       = 33;  // "!     "
  etError34       = 34;  // "!       "
  etError35       = 35;  // "!   "
  etError36       = 36;  // "!    "
  etError37       = 37;  // "!      "
  etError38       = 38;  // "!    "
  etError39       = 39;  // "!     "
  etError40       = 40;  // "!    '
  etError41       = 41;  // "!     "
  etError42       = 42;  // "!     "
  etError43       = 43;  // "!     "
  etError44       = 44;  // "!     "
  etError45       = 45;  // "!     \n\r  "
  etError46       = 46;  // "!   "
  etError47       = 47;  // "!   "
  etError48       = 48;  // "!   
  etError49       = 49;  // "!        NULL"
  etError50       = 50;  // "!   
  etError51       = 51;  // "!   
  etError52       = 52;  // "! Bezier-   "
  etError53       = 53;  // "!   "
  etError54       = 54;  // "!      "
  etError55       = 55;  // "!      "
  etError56       = 56;  // "!   "
  etError57       = 57;  // "!     "
  etError58       = 58;  // "!    "
  etError59       = 59;  // "!      "
  etError60       = 60;  // "!     "
  etError61       = 61;  // "!    .\n\r      "
  etError62       = 62;  // "!    "
  etError63       = 63;  // "!      "
  etError64       = 64;  // "!   "
  etError65       = 65;  // "!     "
  etError66       = 66;  // "!     "
  etError67       = 67;  // "!    "
  etError68       = 68;  // "   "
  etError69       = 69;  // "!      "
  etError70       = 70;  // "    "
  etError71       = 71;  // "!      "
  etError72       = 72;  // "!    "
  etError73       = 73;  // "!    "
  etError74       = 74;  // "!  "
  etError75       = 75;  // "!    "
  etError76       = 76;  // "!     "
  etError77       = 77;  // "!    "
  etError78       = 78;  // "!    "
  etError79       = 79;  // "!    "
  etError80       = 80;  // "!    "
  etError81       = 81;  // "!        "
  etError82       = 82;  // "!    "
  etError83       = 83;  // "!     "
  etError84       = 84;  // "!    "
  etError85       = 85;  // "!    "
  etError86       = 86;  // "!     ""
  etError87       = 87;  // "!     ""
  etError88       = 88;  // "!     \n\r  "
  etError89       = 89;  // "!       "
  etError90       = 90;  // "       "
  etError91       = 91;  // "       "
  etError92       = 92;  // "!     \n\r  "
  etError93       = 93;  // "!          "
  etError94       = 94;  // "       "
  etError95       = 95;  // "!          "
  etError96       = 96;  // "!      \n\r  "
  etError97       = 97;  // "! Nurbs-   "
  etError98       = 98;  // "!      "
  etError99       = 99;  // "!    "
  etError100      = 100; // "!     "
  etError101      = 101; // "!        "
  etError102      = 102; // "!    "
  etError103      = 103; // "    "
  etError104      = 104; // "!      ./n /r    "
  etError105      = 105; // "!       "
  etError106      = 106; // "!       "
  etError107      = 107; // "!       "
  etError108      = 108; // "!    "
  etError109      = 109; // "!    "
  etError110      = 110; // "!    "
  etError111      = 111; // "!    "
  etError112      = 112; // "!       "
  etError113      = 113; // "!         "
  etError114      = 114; // "!    "
  etError115      = 115; // "!    "
  etError116      = 116; // "!       "
  etError117      = 117; // "!      \n\r  "
  etError118      = 118; // "!    "
  etError119      = 119; // "!     "
  etError120      = 120; // "!     "
  etError121      = 121; // "!    "
  etError122      = 122; // "!     "
  etError123      = 123; // "!      "
  etError124      = 124; // "!      "
  etError125      = 125; // "!     "
  etError126      = 126; // "!    "
  etError127      = 127; // "!     \n\r  "
  etError128      = 128; // "!       "
  etError129      = 129; // "!    "
  etError130      = 130; // "!     "
  etError131      = 131; // "     "
  etError132      = 132; // "     "
  etError133      = 133; // "      "
  etError134      = 134; // "!        "
  etError135      = 135; // "        "
  etError136      = 136; // "!     "
  etError137      = 137; // "    "
  etError138      = 138; // "!       "
  etError139      = 139; // "      "
  etError140      = 140; // "!    "
  etError141      = 141; // "!    "
  etError142      = 142; // "        "
  etError143      = 143; // "      "
  etError144      = 144; // "   "
  etError145      = 145; // "!  c    "
  etError146      = 146; // "     "
  etError147      = 147; // "   "
  etError148      = 148; //       "
  etError149      = 149; //        "
  etError150      = 150; // "   "
  etError151      = 151; // "   "
  etError152      = 152; // "!    graphic.tol  ."
  etError153      = 153; // "    \n\r  "
  etError154      = 154; //      :   ,   .
  etError155      = 155; //      .
  etError156      = 156; //      :\n    \" \".
  etError157      = 157; //        :\n  ,   
  etError158      = 158; //        .
  etError159      = 159; //        :\n    \" \".
  etError160      = 160; //       
  etError161      = 161; //       
  etError162      = 162; // O   
  etError163      = 163; //   .\n   \n  .
  etError164      = 164; //     
  etError165      = 165; //       (65536 x 65536)
  etError166      = 166; //       
  etError167      = 167; //       

  MAXERROR        = 167;

//    GetObjParam  SetObjParam
  ALLPARAM             =-3;   //   
  SHEET_ALLPARAM       =-4;   //     ALLPARAM       
  ANGLE_ARC_PARAM      = 0;   //    
  POINT_ARC_PARAM      = 1;   //    
  VIEW_LAYER_STATE     = 1;   //   ,
  DOCUMENT_STATE       = 1;   //  
  DOCUMENT_SIZE        = 0;   //  
  DIM_TEXT_PARAM       = 0;   //    
  DIM_SOURSE_PARAM     = 1;   //   
  DIM_DRAW_PARAM       = 2;   //   
  DIM_VALUE            = 3;   //   - double
  DIM_PARTS            = 4;   //     struct DimensionPartsParam
  SHEET_DIM_PARTS      = 5;   //     struct DimensionPartsParam   
  TECHNICAL_DEMAND_PAR =-1;   //    -
  TT_FIRST_STR         = 1000;//          
  CONIC_PARAM          = 2;   //      (      )
  SPC_TUNING_PARAM     = 0;   //     
  HATCH_PARAM_EX       = 0;   //   

// 
  ALL_OBJ               = 0;  //  ,  ,                         -
  LINESEG_OBJ           = 1;  // 
  CIRCLE_OBJ            = 2;  // 
  ARC_OBJ               = 3;  // 
  TEXT_OBJ              = 4;  // 
  POINT_OBJ             = 5;  // 
  HATCH_OBJ             = 7;  // 
  BEZIER_OBJ            = 8;  // bezier 
  LDIMENSION_OBJ        = 9;  //  
  ADIMENSION_OBJ        = 10; //  
  DDIMENSION_OBJ        = 13; //  
  RDIMENSION_OBJ        = 14; //  
  RBREAKDIMENSION_OBJ   = 15; //    
  ROUGH_OBJ             = 16; // 
  BASE_OBJ              = 17; // 
  WPOINTER_OBJ          = 18; //  
  CUT_OBJ               = 19; //  
  LEADER_OBJ            = 20; //   
  POSLEADER_OBJ         = 21; //     
  BRANDLEADER_OBJ       = 22; //     
  MARKERLEADER_OBJ      = 23; //     
  TOLERANCE_OBJ         = 24; //  
  TABLE_OBJ             = 25; // 
  CONTOUR_OBJ           = 26; // 
  MACRO_OBJ             = 27; //  
  LINE_OBJ              = 28; // 
  LAYER_OBJ             = 29; // 
  FRAGMENT_OBJ          = 30; //  
  POLYLINE_OBJ          = 31; // 
  ELLIPSE_OBJ           = 32; // 
  NURBS_OBJ             = 33; // nurbs 
  ELLIPSE_ARC_OBJ       = 34; //  
  RECTANGLE_OBJ         = 35; // 
  REGULARPOLYGON_OBJ    = 36; // 
  EQUID_OBJ             = 37; // 
  LBREAKDIMENSION_OBJ   = 38; //    
  ABREAKDIMENSION_OBJ   = 39; //    
  ORDINATEDIMENSION_OBJ = 40; //  
  COLORFILL_OBJ         = 41; //   
  CENTREMARKER_OBJ      = 42; //  
  ARCDIMENSION_OBJ      = 43; //   
  SPC_OBJ               = 44; //              
  RASTER_OBJ            = 45; //  
  CHANGE_LEADER_OBJ     = 46; //            -
  REMOTE_ELEMENT_OBJ    = 47; //                 -

  SPECIFICATION_OBJ     = 121; //   
  SPECROUGH_OBJ         = 122; //  
  VIEW_OBJ              = 123; // 
  DOCUMENT_OBJ          = 124; //   
  TECHNICALDEMAND_OBJ   = 125; //  
  STAMP_OBJ             = 126; // 
  SELECT_GROUP_OBJ      = 127; //  
  NAME_GROUP_OBJ        = 128; //  
  WORK_GROUP_OBJ        = 129; //  
  SPC_DOCUMENT_OBJ      = 130; //   
  D3_DOCUMENT_OBJ       = 131; // 3d     
  CHANGE_LIST_OBJ       = 132; //  

  MAX_TIP_SEARCH        = 132;  //    

//  
  ODBC_DB = 0;
  TXT_DB  = 1;

  TXT_CHAR   = 1;
  TXT_USHORT = 2;
  TXT_SSHORT = 3;
  TXT_SLONG  = 4;
  TXT_ULONG  = 5;
  TXT_LONG   = 6;
  TXT_FLOAT  = 7;
  TXT_DOUBLE = 8;
  TXT_INT    = 9;
  TXT_ALL    = 0;
  TXT_INDEX  = 'Index1000';

//   
  stACTIVE    = 0;  // , 
  stREADONLY  = 1;  // 
  stINVISIBLE = 2;  // 
  stCURRENT   = 3;  // 
  stPASSIVE   = 1;  // 

//    ksSytemPath
  sptSYSTEM_FILES = 0; //      
  sptLIBS_FILES   = 1; //      
  sptTEMP_FILES   = 2; //       
  sptCONFIG_FILES = 3; //       
  sptINI_FILE     = 4; //    INI- 
  sptBIN_FILE 	  = 5; //       

// o    SystemControlStart
  scsSTOPPED_FOR_MENU_COMMAND      =  1; //    "  "
  scsSTOPPED_FOR_SYSTEM_STOP       =  0; //   
  scsSTOPPED_FOR_ITSELF            = -1; //   SystemControlStop - 
  scsSTOPPED_FOR_START_THIS_LIB    = -2; //       
  scsSTOPPED_FOR_START_ANOTHER_LIB = -3; //      

// o   
  INVARIABLE         =  0;   //    
  NUMERATOR          =  $1;  // 
  DENOMINATOR        =  $2;  // 
  END_FRACTION       =  $3;  //  
  UPPER_DEVIAT       =  $4;  //  
  LOWER_DEVIAT       =  $5;  //  
  END_DEVIAT         =  $6;  //   
  S_BASE             =  $7;  //    
  S_UPPER_INDEX      =  $8;  //     
  S_LOWER_INDEX      =  $9;  //     
  S_END              =  $10; //    
  SPECIAL_SYMBOL     =  $11; // 
  SPECIAL_SYMBOL_END =  $12; //    
  RETURN_BEGIN       =  $13; //         , , 
  RETURN_DOWN        =  $14; //        , , 
  RETURN_RIGHT       =  $15; //        , , 
  TAB                =  $16; //    
  FONT_SYMBOL        =  $17; //  

  ITALIC_ON          = $40;  //  
  ITALIC_OFF         = $80;  //  
  BOLD_ON            = $100; //  
  BOLD_OFF           = $200; //  
  UNDERLINE_ON       = $400; //  
  UNDERLINE_OFF      = $800; //  
  NEW_LINE           = $1000; //    

  LIKE_BASIC_LINE = $10; //      
  LIKE_THIN_LINE  = $20; //      
  LIKE_HEAVY_LINE = $30; //      

  FONT_NAME      =  1; //  
  NARROWING      =  2; //   
  HEIGHT         =  3; //  
  COLOR          =  4; //  
  SPECIAL        =  5; // 
  FRACTION_TYPE  =  6; //       1-  2- 1.5   3- 2  
  SUM_TYPE       =  7; //         1-  2- 1.5  

//    
  CHAR_STR_ARR           = 1 ; //     
  POINT_ARR              = 2 ; //      - MathPointParam
  CURVE_PATTERN_ARR      = 2 ; //       - CurvePattern
  TEXT_LINE_ARR          = 3 ; //    -  TextLineParam
  TEXT_ITEM_ARR          = 4 ; //      TextItemParam
  ATTR_COLUMN_ARR        = 5 ; //   -   ColumnInfo
  USER_ARR               = 6 ; //  
  POLYLINE_ARR           = 7 ; //  -(  POINT_ARR)
  RECT_ARR               = 8 ; //   -( RectParam)
  LIBRARY_STYLE_ARR      = 9 ; //        ( LibraryStyleParam )
  VARIABLE_ARR           = 10; //     ( VariableParam )
  CURVE_PATTERN_ARR_EX   = 11; //       - CurvePatternEx
  LIBRARY_ATTR_TYPE_ARR  = 12; //          ( LibraryAttrTypeParam )
  NURBS_POINT_ARR        = 13; //   NurbsPointParam
  DOUBLE_ARR             = 14; //  duuble
  CONSTRAIN_ARR          = 15; //    -  ConstrainParam
  CORNER_ARR             = 16; //     CornerParam    
  DOC_SPCOBJ_ARR         = 17; //        
  SPCSUBSECTION_ARR      = 18; //       SpcSubSectionParam
  SPCTUNINGSEC_ARR       = 19; //        SpcTuningSectionParam
  SPCSTYLECOLUMN_ARR     = 20; //         SpcStyleColumnParam
  SPCSTYLESEC_ARR        = 21; //      a  SpcStyleSectionParam
  QUALITYITEM_ARR        = 22; //    QualityItemParam -      - 
  LTVARIANT_ARR          = 23; //    LtVariant
  TOLERANCEBRANCH_ARR    = 24; //    ToleranceBranch
  HATCHLINE_ARR          = 25; //    HatchLineParam

//     
  CHAR_ATTR_TYPE    = 1;
  UCHAR_ATTR_TYPE   = 2;
  INT_ATTR_TYPE     = 3;
  UINT_ATTR_TYPE    = 4;
  LINT_ATTR_TYPE    = 5;
  FLOAT_ATTR_TYPE   = 6;
  DOUBLE_ATTR_TYPE  = 7;
  STRING_ATTR_TYPE  = 8; //    MAX_TEXT_LENGTH
  RECORD_ATTR_TYPE  = 9;

// o   
  _AUTONOMINAL       =  $1;   //   
  _RECTTEXT          =  $2;   //   
  _PREFIX            =  $4;   //    
  _NOMINALOFF        =  $8;   //   
  _TOLERANCE         =  $10;  //  
  _DEVIATION         =  $20;  //  
  _UNIT              =  $40;  //  
  _SUFFIX            =  $80;  //    
  _DEVIATION_INFORM  =  $100; //   _DEVIATION,     (      ).
  _UNDER_LINE        =  $200; // >0   

  INDICATIN_TEXT_LINE_ARR = $FFFF; //  ,   ,   
                                   // ,       TEXT_LINE_ARR
//  
  CURVE_STYLE    = 1; //  
  HATCH_STYLE    = 2; //  
  TEXT_STYLE     = 3; //  
  STAMP_STYLE    = 4; //  
  CURVE_STYLE_EX = 5; //   

// o   GetDocOptions
  DIMENTION_OPTIONS = 1;    // 
  ARROWFILLING_OPTIONS = 2; //   ?

//    
  SPC_CLM_FORMAT   = 1;  // 
  SPC_CLM_ZONE     = 2;  // 
  SPC_CLM_POS      = 3;  // 
  SPC_CLM_MARK     = 4;  // 
  SPC_CLM_NAME     = 5;  // 
  SPC_CLM_COUNT    = 6;  // 
  SPC_CLM_NOTE     = 7;  // 
  SPC_CLM_MASSA    = 8;  // 
  SPC_CLM_MATERIAL = 9;  // 
  SPC_CLM_USER     = 10; // 
  SPC_CLM_KOD      = 11; // 
  SPC_CLM_FACTORY  = 12; //  

//    
  SPC_INT    = 1; // 
  SPC_DOUBLE = 2; // 
  SPC_STRING = 3; // 
  SPC_RECORD = 4; // 

//   
  CURVE_STYLE_LIBRARY           =  1; //    (*.lcs)
  HATCH_STYLE_LIBRARY           =  2; //    (*.lhs)
  TEXT_STYLE_LIBRARY            =  3; //      (*.lts)
  STAMP_LAYOUT_STYLE_LIBRARY    =  4; //     (*.lyt)
  GRAPHIC_LAYOUT_STYLE_LIBRARY  =  5; //      (*.lyt)
  TEXT_LAYOUT_STYLE_LIBRARY     =  6; //      (*.lyt)
  SPC_LAYOUT_STYLE_LIBRARY      =  7; //     (*.lyt)

//       - 
  ST_MIX_MM  = $1;  // 
  ST_MIX_SM  =  0;  // 
  ST_MIX_DM  = $2;  // 
  ST_MIX_M   = $3;  // 
  ST_MIX_GR  =  0;  // 
  ST_MIX_KG  = $10; // 
  ST_MIX_EXT =  0;  // 
  ST_MIX_RV  = $20; // 

//   
  SN_NEAREST_POINT  = 1; //  
  SN_NEAREST_MIDDLE = 2; // 
  SN_CENTRE         = 3; // 
  SN_INTERSECT      = 4; // 
  SN_GRID           = 5; //  
  SN_XY_ALIGN       = 6; // 
  SN_ANGLE          = 7; //  
  SN_POINT_CURVE    = 8; //   

//     
  SN_DYNAMICALLY      = $1; //   
  SN_ASSISTANT        = $2; //  
  SN_BACKGROUND_LAYER = $4; //     
  SN_SUSPENDED        = $8; //  

// o   GetSysOptions  SetSysOptions
  SNAP_OPTIONS = 1; //  

//   
  CONSTRAINT_FIXED_POINT      =  1; //  
  CONSTRAINT_POINT_ON_CURVE   =  2; //   
  CONSTRAINT_HORIZONTAL       =  3; // 
  CONSTRAINT_VERTICAL         =  4; // 
  CONSTRAINT_PARALLEL         =  5; //     
  CONSTRAINT_PERPENDICULAR    =  6; //     
  CONSTRAINT_EQUAL_LENGTH     =  7; //    
  CONSTRAINT_EQUAL_RADIUS     =  8; //    /
  CONSTRAINT_HOR_ALIGN_POINTS =  9; //     
  CONSTRAINT_VER_ALIGN_POINTS = 10; //     
  CONSTRAINT_MERGE_POINTS     = 11; //   
  
//   
  SPC_BASE_OBJECT  = 1; //   (   )
  SPC_COMMENT      = 2; //  (   )
  SPC_SECTION_NAME = 3; //   (      )
  SPC_BLOCK_NAME   = 4; //    (      )
  SPC_RESERVE_STR  = 5; //   (      )
  SPC_EMPTY_STR    = 6; //   (      )

//  
  SPC_SORT_OFF      = 0; //  
  SPC_SORT_COMPOS   = 1; //  
  SPC_SORT_ALPHABET = 2; //   
  SPC_SORT_UP       = 3; //    
  SPC_SORT_DOCUMENT = 4; //   
  SPC_SORT_DOWN     = 5; //    
  SPC_SORT_COMPOSDOWN = 6; //     

//    (   )
  ARROW_INSIDE_SYMBOL       = 1;  //  
  ARROW_OUT_SIDE_SYMBOL     = 2;  //  
  TICK_TAIL_SYMBOL          = 3;  //     ( )
  UP_HALF_ARROW_SYMBOL      = 4;  //    
  DOWN_HALF_ARROW_SYMBOL    = 5;  //    
  BIG_ARROW_INSIDE_SYMBOL   = 6;  //    (7)
  ARROW_ORDINATE_DIM_SYMBOL = 7;  //    (  4    45 )
  TRIANGLE_SYMBOL           = 8;  //   - 
  CIRCLE_RAD2_SYMBOL        = 9;  //   2    -  -  -
  CENTRE_MARKER_SYMBOL      = 10; //       
  GLUE_SIGN_SYMBOL          = 11; //  
  SOLDER_SIGN_SYMBOL        = 12; //  
  SEWING_SIGN_SYMBOL        = 13; //  
  CRAMP_SIGN_SYMBOL         = 14; //    .
  CORNER_CRAMP_SIGN_SYMBOL  = 15; //    .
  MONTAGE_JOINT_SYMBOL      = 16; //   
  TICK_SYMBOL               = 17; //     ( )
  TRIANGLE_CURR_CS          = 18; //     -  


//------------------------------------------------------------------------------
//     ksSetMacroParam;
//      
// ---
  MP_DBL_CLICK_OFF   = $01; //>0     
  MP_HOTPOINTS       = $02; //>0  hot  
  MP_EXTERN_EDIT     = $03; //>0   

//   DocType
  lt_DocSheetStandart = 1;  //  
  lt_DocSheetUser     = 2;  //  
  lt_DocFragment      = 3;  // 
  lt_DocSpc           = 4;  // 
  lt_DocPart3D        = 5;  // 3d- 
  lt_DocAssemble3D    = 6;  // 3d- 

//   LtQualSystem
  lt_qsShaft = 1; // 
  lt_qsHole  = 2; // 

//  LtQualDir
  lt_qdPreferable = 1; // 
  lt_qdBasic      = 2; // 
  lt_qdAdditional = 3; // 

//    LtVariant - LtVariantType
  ltv_Char   = 1;  // 
  ltv_UChar  = 2;  // 
  ltv_Int    = 3;  // 
  ltv_UInt   = 4;  //  
  ltv_Long   = 5;  //  
  ltv_Float  = 6;  // 
  ltv_Double = 7;  //  
  ltv_Str    = 8;  //  255 
  ltv_NoUsed = 9;  //   
  ltv_Short  = 10; //  

//   
  OD_FRONTVIEW      = $00; //   ,    ,   
  OD_TOPVIEW        = $08; //     - -    
  OD_TOPVIEWLEADER  = $10; //     -

//-----------------------------------------------------------------------------
//     
// ---
  FORMAT_BMP  = 0;
  FORMAT_GIF  = 1;
  FORMAT_JPG  = 2;
  FORMAT_PNG  = 3;
  FORMAT_TIF  = 4;
  FORMAT_TGA  = 5;
  FORMAT_PCX  = 6;

//-----------------------------------------------------------------------------
//     
// ---
  BLACKWHITE  = 0;   // 
  COLORVIEW   = 1;   //   
  COLORLAYER  = 2;   //   
  COLOROBJECT = 3;   //   

//-----------------------------------------------------------------------------
//         
// ---
  BPP_COLOR_01 = 1;  //""
  BPP_COLOR_02 = 2;  //"4 "
  BPP_COLOR_04 = 4;  //"16 "
  BPP_COLOR_08 = 8;  //"256 "
  BPP_COLOR_16 = 16; //"16 "
  BPP_COLOR_24 = 24; //"24 "
  BPP_COLOR_32 = 32; //"32 "

//     GetParamStruct  KompasObject - StructType2D
  ko_Type1 = 1;                    //  ksType1                     
  ko_Type2 = 2;                    //  ksType2                     
  ko_Type3 = 3;                    //  ksType3                     
  ko_Type5 = 4;                    //  ksType5                     
  ko_Type6 = 5;                    //  ksType6                     
  ko_Phantom = 6;                  //  ksPhantom                 
  ko_PlacementParam = 7;           //  ksPlacementParam          
  ko_ViewParam = 8;                //  ksViewParam               
  ko_LayerParam = 9;               //  ksLayerParam              
  ko_RequestInfo = 10;             //  ksRequestInfo             
  ko_LineSegParam = 11;            //  ksLineSegParam            
  ko_ArcByAngleParam = 12;         //  ksArcByAngleParam             
  ko_ArcByPointParam = 13;         //  ksArcByPointParam              
  ko_MathPointParam = 14;          //  ksMathPointParam           
  ko_RectParam = 15;               //  ksRectParam                
  ko_PointParam = 16;              //  ksPointParam               
  ko_BezierPointParam = 17;        //  ksBezierPointParam             Bezier - 
  ko_NurbsPointParam = 18;         //  ksNurbsPointParam         Nurbs-
  ko_BezierParam = 19;             //  ksBezierParam             Bezier 
  ko_CircleParam = 20;             //  ksCircleParam             
  ko_LineParam = 21;               //  ksLineParam               
  ko_EllipseParam = 22;            //  ksEllipseParam            
  ko_EllipsArcParam = 23;          //  ksEllipsArcParam           
  ko_EllipsArcParam1 = 24;         //  ksEllipsArcParam1          
  ko_EquidParam = 25;              //  ksEquidParam              
  ko_HatchParam = 26;              //  ksHatchParam              
  ko_ParagraphParam = 27;          //  ksParagraphParam           
  ko_TextParam = 28;               //  ksTextParam               
  ko_TextLineParam = 29;           //  ksTextLineParam            
  ko_TextItemFont = 30;            //  ksTextItemFont               
  ko_TextItemParam = 31;           //  ksTextItemParam             
  ko_StandartSheet = 32;           //  ksStandartSheet            
  ko_SheetSize = 33;               //  ksSheetSize                
  ko_SheetPar = 34;                //  ksSheetPar                
  ko_DocumentParam = 35;           //  ksDocumentParam           
  ko_ColumnInfoParam = 36;         //  ksColumnInfoParam          
  ko_AttributeType = 37;           //  ksAttributeType            
  ko_Attribute = 38;               //  ksAttribute                
  ko_LibraryAttrTypeParam = 39;    //  ksLibraryAttrTypeParam   
  ko_TAN = 40;                     //  ksTAN                      
  ko_CON = 41;                     //  ksCON                      
  ko_DimText = 42;                 //  ksDimText                 
  ko_LDimSource = 43;              //  ksLDimSource                 
  ko_DimDrawing = 44;              //  ksDimDrawing                  
  ko_LDimParam = 45;               //  ksLDimParam                
  ko_LBreakDimSource = 46;         //  ksLBreakDimSource          .   
  ko_BreakDimDrawing = 47;         //  ksBreakDimDrawing               
  ko_LBreakDimParam = 48;          //  ksLBreakDimParam             
  ko_ADimSource = 49;              //  ksADimSource                
  ko_ADimParam = 50;               //  ksADimParam                
  ko_ABreakDimParam = 51;          //  ksABreakDimParam           
  ko_RDimSource = 52;              //  ksRDimSource                  
  ko_RDimDrawing = 53;             //  ksRDimDrawing                  
  ko_RDimParam = 54;               //  ksRDimParam                      C         
  ko_RBreakDrawing = 55;           //  ksRBreakDrawing               
  ko_RBreakDimParam = 56;          //  ksRBreakDimParam              
  ko_RoughPar = 57;                //  ksRoughPar                 
  ko_ShelfPar = 58;                //  ksShelfPar                  
  ko_RoughParam = 59;              //  ksRoughParam              
  ko_LeaderParam = 60;             //  ksLeaderParam               
  ko_PosLeaderParam = 61;          //  ksPosLeaderParam              
  ko_BrandLeaderParam = 62;        //  ksBrandLeaderParam            
  ko_MarkerLeaderParam = 63;       //  ksMarkerLeaderParam           
  ko_BaseParam = 64;               //  ksBaseParam              
  ko_CutLineParam = 65;            //  ksCutLineParam             /
  ko_ViewPointerParam = 66;        //  ksViewPointerParam         
  ko_ToleranceBranch = 67;         //  ksToleranceBranch           
  ko_ToleranceParam = 68;          //  ksToleranceParam           
  ko_CurvePattern = 69;            //  ksCurvePattern              
  ko_CurvePicture = 70;            //  ksCurvePicture             
  ko_CurvePatternEx = 71;          //  ksCurvePatternEx             
  ko_CurveStyleParam = 72;         //  ksCurveStyleParam          
  ko_DimensionPartsParam = 73;     //  ksDimensionPartsParam       
  ko_TextStyleParam = 74;          //  ksTextStyleParam           
  ko_ConicArcParam = 75;           //  ksConicArcParam            
  ko_PolylineParam = 76;           //  ksPolylineParam           
  ko_LibStyle = 77;                //  ksLibStyle                    
  ko_TechnicalDemandParam = 78;    //  ksTechnicalDemandParam       
  ko_SpecRoughParam = 79;          //  ksSpecRoughParam             
  ko_DimensionOptions = 80;        //  ksDimensionOptions           
  ko_SpcColumnParam = 81;          //  ksSpcColumnParam            
  ko_LibraryStyleParam = 82;       //  ksLibraryStyleParam           
  ko_InertiaParam = 83;            //  ksInertiaParam               - 
  ko_MassInertiaParam = 84;        //  ksMassInertiaParam          - 
  ko_VariableParam = 85;           //  ksVariableParam          
  ko_SnapOptions = 86;             //  ksSnapOptions                
  ko_NurbsParam = 87;              //  ksNurbsParam              Nurbs-
  ko_InsertFragmentParam = 88;     //  ksInsertFragmentParam      
  ko_ConstraintParam = 89;         //  ksConstraintParam         
  ko_CornerParam = 90;             //  ksCornerParam             
  ko_RectangleParam = 91;          //  ksRectangleParam          
  ko_RegularPolygonParam = 92;     //  ksRegularPolygonParam     
  ko_CentreParam = 93;             //  ksCentreParam              
  ko_DocAttachSpcParam = 94;       //  ksDocAttachSpcParam           
  ko_SpcObjParam = 95;             //  ksSpcObjParam              
  ko_RasterParam = 96;             //  ksRasterParam              
  ko_RecordTypeAttrParam = 97;     //  ksRecordTypeAttrParam            RECORD_ATTR_TYPE
  ko_NumberTypeAttrParam = 98;     //  ksNumberTypeAttrParam            DOUBLE_ATTR_TYPE  LINT_ATTR_TYPE
  ko_SpcStyleColumnParam = 99;     //  ksSpcStyleColumnParam       
  ko_SpcStyleSectionParam = 100;   //  ksSpcStyleSectionParam     a 
  ko_SpcSubSectionParam = 101;     //  ksSpcSubSectionParam       
  ko_SpcTuningSectionParam = 102;  //  ksSpcTuningSectionParam     
  ko_SpcTuningStyleParam = 103;    //  ksSpcTuningStyleParam       
  ko_SpcStyleParam = 104;          //  ksSpcStyleParam            
  ko_SpcDescrParam = 105;          //  ksSpcDescrParam            
  ko_QualityItemParam = 106;       //  ksQualityItemParam             - 
  ko_QualityContensParam = 107;    //  ksQualityContensParam     
  ko_LtVariant = 108;              //  ksLtVariant               
  ko_ContourParam = 109;           //  ksContourParam            
  ko_DoubleValue = 110;            //  ksDoubleValue             Nurbs-
  ko_Char255 = 111;                //  ksChar255                 
  ko_UserParam = 112;              //  ksUserParam                Get/Set Macroparam   ReadRecord
  ko_HatchLineParam = 113;         //  ksHatchLineParam           
  ko_HatchStyleParam = 114;        //  ksHatchStyleParam          
  ko_OrdinatedSourceParam = 115;   //  ksOrdinatedSourceParam      
  ko_OrdinatedDrawingParam = 116;  //  ksOrdinatedDrawingParam     
  ko_OrdinatedDimParam = 117;      //  ksOrdinatedDimParam        
  ko_SheetOptions      = 118;      //  ksSheetParOptions         
  ko_InsertFragmentParamEx = 119;  //  ksInsertFragmentParamEx    

implementation
end.






