////////////////////////////////////////////////////////////////////////////////
//  System: K-3D API
//  Module: LDefin3D
////////////////////////////////////////////////////////////////////////////////
unit LDefin3D;

{$ALIGN OFF}

interface 

type
  Reference = Longint;

const  
  et3dNo3dDocument  =-7;  // "      3D-"
  et3dAbort         =-1;  // "  (?)"
  et3dError1        = 1;  // "3D   "
  et3dError2        = 2;  // " 3D-  "
  et3dError3        = 3;  // "    3D-"
  et3dError4        = 4;  // " 3D-   "
  et3dError5        = 5;  // "      3D-"
  et3dError6        = 6;  // "   "
  et3dError7        = 7;  // "   3D   "
  et3dError8        = 8;  // "    "
  et3dError9        = 9;  // "    "
  et3dError10       = 10; // "    "
  et3dError11       = 11; // "  "
  et3dError12       = 12; // "   ""
  et3dError13       = 13; // " "
  et3dError14       = 14; // "   "
  et3dError15       = 15; // " "
  et3dError16       = 16; // "    "
  et3dError17       = 17; // "     (     )"
  et3dError18       = 18; // "    "
  et3dError19       = 19; // "   "
  et3dError20       = 20; // "   "
  et3dError21       = 21; // "   "
  et3dError22       = 22; // "   "
  et3dError23       = 23; // "    "
  et3dError24       = 24; // " "
  et3dError25       = 25; // " "
  et3dError26       = 26; // " "
  et3dError27       = 27; // " "
  et3dError28       = 28; // " "
  et3dError29       = 29; // "  "
  et3dError30       = 30; // "      (     )"
  et3dError31       = 31; // " "
  et3dError32       = 32; // "  "
  et3dError33       = 33; // "   "
  et3dError34       = 34; // "   "
  et3dError35       = 35; // "  "
  et3dError36       = 36; // "   "
  et3dError37       = 37; // "    "
  et3dError38       = 38; // "    "
  et3dError39       = 39; // "     "
  et3dError40       = 40; // "   "
  et3dError41       = 41; // "     "
  et3dError42       = 42; // "     "
  et3dError43       = 43; // "   "
  et3dError44       = 44; // "   "
  et3dError45       = 45; // "     "
  et3dError46       = 46; // "   "
  et3dError47       = 47; // "  "
  et3dError48       = 48; // "    "
  et3dError49       = 49; // "       "
  et3dError50       = 50; // " "
  et3dError51       = 51; // " "
  et3dError52       = 52; // "    "
  et3dError53       = 53; // "    "
  et3dError54       = 54; // " "
  et3dError55       = 55; // "    "
  et3dError56       = 56; // "   "
  et3dError57       = 57; // "   "
  et3dError58       = 58; // "    "
  et3dError59       = 59; // "   "
  et3dError60       = 60; // 
  et3dError61       = 61; // "     "
  et3dError62       = 62; // "    "
  et3dError63       = 63; // "     3D- "
  et3dError64       = 64; // " 3D   "
  et3dError65       = 65; // "   3D- "
  et3dError66       = 66; //   66     
  et3dError67       = 67; //   67      
  et3dError68       = 68; //   68     
  et3dError69       = 69; //   69          
  et3dError70       = 70; //   70    
  et3dError71       = 71; //   71       
  et3dError72       = 72; //   72    
  et3dError73       = 73; //   73     
  et3dError74       = 74; //   74      
  et3dError75       = 75; //   75      
  et3dError76       = 76; //   76       "
  et3dError77       = 77; //   77        "
  et3dError78       = 78; //   78 !     
  et3dError79       = 79; //   79 !    
  et3dError80       = 80; //   80 !       
  et3dError81       = 81; //   81 !       
  et3dError82       = 82; //   82    
  et3dError83       = 83; //   83    
  et3dError84       = 84; //   84    
  et3dError85       = 85; //   85     
  et3dError86       = 86; //   86    
  et3dError87       = 87; //   87     
  et3dError88       = 88; //   88 "    "
  et3dError89       = 89; //   89      
  et3dError90       = 90; //   90    
  et3dError91       = 91; //   91 "     "
  et3dError92       = 92; //   92 "  "
  et3dError93       = 93; //   93 "    "
  et3dError94       = 94; //   94         
  et3dError95       = 95; //   95     
  et3dError96       = 96; //   96    ,   

  MAXERROR3D = 96;

//   Direction_Type
  dtNormal = 0;      //  
  dtReverse = 1;     //  
  dtBoth = 2;        //   
  dtMiddlePlane = 3; //  

//   End_Type
  etBlind = 0;           //   
  etThroughAll = 1;      //   
  etUpToVertexTo = 2;    //    
  etUpToVertexFrom = 3;  //    
  etUpToSurfaceTo = 4;   //    
  etUpToSurfaceFrom = 5; //    
  etUpToNearSurface = 6; //   

//  Part_Type
  pNew_Part  = -3;  //  
  pEdit_Part = -2;  //  
  pTop_Part  = -1;  //  

//   MateConstraintType
  mc_Coincidence = 0;    // / 
  mc_Parallel = 1;       // 
  mc_Perpendicular = 2;  // 
  mc_Tangency = 3;       // 
  mc_Concentric = 4;     // 
  mc_Distance = 5;       //   
  mc_Angle = 6;          //   
  mc_InPlace = 7;        //    

//  Obj3dType
//------------------------------------------------------------------------------
//     enum'    D3LtEntityCollection::IsOurEntity
// ---
  o3d_unknown = 0;         //  (  )
  // default' 
  o3d_planeXOY = 1;         // 1  XOY
  o3d_planeXOZ = 2;         // 2  XOZ
  o3d_planeYOZ = 3;         // 3  YOZ
  o3d_pointCS  = 4;         // 4    

  //  
  o3d_sketch   = 5;         // 5 
  o3d_face     = 6;         // 6 
  o3d_edge     = 7;         // 7 
  o3d_vertex   = 8;         // 8 

  //  
  o3d_axis2Planes  = 9;     // 9    
  o3d_axis2Points  = 10;    // 10    
  o3d_axisConeFace = 11;    // 11   
  o3d_axisEdge     = 12;    // 12    
  o3d_axisOperation= 13;    // 13  
  o3d_planeOffset  = 14;    // 14  
  o3d_planeAngle   = 15;    // 15   
  o3d_plane3Points = 16;    // 16   3- 
  o3d_planeNormal  = 17;    // 17  
  o3d_planeTangent = 18;    // 18  
  o3d_planeEdgePoint = 19;  // 19     
  o3d_planeParallel  = 20;  // 20      
  o3d_planePerpendicular = 21;   // 21     
  o3d_planeLineToEdge  = 22; // 22    -/-  
  o3d_planeLineToPlane = 23; // 23    -/- 

  // 
  o3d_baseExtrusion = 24;   // 24   
  o3d_bossExtrusion = 25;   // 25  
  o3d_cutExtrusion  = 26;   // 26  
  o3d_baseRotated   = 27;   // 27   
  o3d_bossRotated   = 28;   // 28  
  o3d_cutRotated    = 29;   // 29  
  o3d_baseLoft      = 30;   // 30    
  o3d_bossLoft      = 31;   // 31   
  o3d_cutLoft       = 32;   // 32   
  o3d_chamfer       = 33;   // 33  ""
  o3d_fillet        = 34;   // 34  ""
  o3d_meshCopy      = 35;   // 35    
  o3d_circularCopy  = 36;   // 36     
  o3d_curveCopy     = 37;   // 37    
  o3d_circPartArray = 38;   // 38       
  o3d_meshPartArray = 39;   // 39      
  o3d_curvePartArray = 40;  // 40      
  o3d_derivPartArray = 41;  // 41      
  o3d_incline        = 42;  // 42  ""
  o3d_shellOperation = 43;  // 43  ""
  o3d_ribOperation   = 44;  // 44  " "
  o3d_baseEvolution  = 45;  // 45  
  o3d_bossEvolution  = 46;  // 46  
  o3d_cutEvolution   = 47;  // 47  
  o3d_mirrorOperation= 48;  // 48  " "
  o3d_mirrorAllOperation = 49; // 49  "  "
  o3d_cutByPlane     = 50;  // 50  " "
  o3d_cutBySketch    = 51;  // 51  " "
  o3d_holeOperation  = 52;  // 52 

  // 
  o3d_polyline       = 53;  // 53 
  o3d_conicSpiral    = 54;  // 54  
  o3d_spline         = 55;  // 55 
  o3d_cylindricSpiral= 56;  // 56


  o3d_lastEntityElement = 56;  // 56    Entity!!!

 	//    Entity
  o3d_variable  = 100;        // 100  
  o3d_placement = 101;        // 101 
  o3d_entityCollection = 102; // 102  3d 
  o3d_document  = 103;        // 103  3d
  o3d_part      = 104;        // 104 
  o3d_entity    = 105;        // 105 
  o3d_mateConstraint = 106;   // 106 
  o3d_mateConstraintCollection = 107; // 107  
  o3d_partCollection = 108;   // 108   

  //      EntityCollection
  o3d_constrElement = 109;    // 109   -    (  o3d_axis2Planes  o3d_plane3Points)
  o3d_operationElement = 110; // 110  ( o3d_baseExtrusion  o3d_fillet)
  o3d_curveElement     = 111; // 111  (  )

  o3d_rasterFormat     = 112; // 112       
  o3d_additionFormat   = 113; // 113        jgs, sat,xt,x_b, step, stl, VRML

//------------------------------------------------------------------------------
//      jgs, sat, xt, step, stl, VRML
// ---
// enum D3FormatConvType
  format_SAT   = 1;
  format_XT    = 2;
  format_STEP  = 3;
  format_IGES  = 4;
  format_VRML  = 5;
  format_STL   = 6;


implementation
end.







